FTPD(8)

NAME
ftpd - Internet File Transfer Protocol server

SYNOPSIS
ftpd [-AdDhlMPSU46] [-T maxtimeout] [-t timeout] [-u mask]

DESCRIPTION
Ftpd is the Internet File Transfer Protocol server process. The server uses the TCP protocol and listens at the port specified in the “ftp” service specification; see services(5).

Available options:

-A  Permit only anonymous ftp connections or accounts listed in /etc/ftpchroot. Other connection attempts are refused.

-d  Debugging information is written to the syslog using LOG_FTP.

-D  With this option set, ftpd will detach and become a daemon, accepting connections on the FTP port and forking child processes to handle them. This has lower overhead than starting ftpd from inetd(8) and is thus useful on busy servers to reduce load.

-h  The server will use data ports in the high port range for passive connections. This range is defined by the IPPORT_HIFIRSTAUTO and IPPORT_HILASTAUTO defines in <netinet/in.h>. In OpenBSD they are set to 49152 and 65535 respectively.

-l  Each successful and failed ftp(1) session is logged using syslog with a facility of LOG_FTP. If this option is specified twice, the retrieve (get), store (put), append, delete, make directory, remove directory and rename operations and their filename arguments are also logged.

-M  Enables multihomed mode. Instead of simply using ~ftp for anonymous transfers, a directory matching the fully qualified name of the IP number the client connected to, and located inside ~ftp is used instead.

-P  Permit illegal port numbers or addresses for PORT command initiated connects. By default ftpd(8) violates the RFC and thus constrains the PORT command to non-reserved ports and requires it use the same source address as the connection came from. This prevents the "FTP bounce attack" against services on both the local machine and other local machines.

-S  With this option set, ftpd logs all anonymous transfers to the file /var/log/ftpd when this file exists.

-U  Each concurrent ftp(1) session is logged to the file /var/run/utmp, making them visible to commands such as who(1). This option at present is unsupporte and will always silently fail.

-T  A client may also request a different timeout period; the maximum period allowed may be set to timeout seconds with the -T option. The default limit is 2 hours.

-t  The inactivity timeout period is set to timeout seconds (the default is 15 minutes).

-u  Change the default umask from 027 to mask.

-6  When -D is specified, accept connections via AF_INET6 socket.

-4  When -D is specified, accept IPv4 connections. When -6 is also specified, accept IPv4 connection via AF_INET6 socket. When -6 is not specified, accept IPv4 connection via AF_INET socket.

The file /etc/nologin can be used to disable ftp access. If the file exists, ftpd displays it and exits. If the file /etc/ftpwelcome exists, ftpd prints it before issuing the “ready” message. If the file /etc/motd exists, ftpd prints it after a successful login. If the file .message exists in a directory, ftpd prints it when that directory is entered.

The ftp server currently supports the following ftp requests. The case of the requests is ignored.
Request | Description
ABOR | abort previous command
ACCT | specify account (ignored)
ALLO | allocate storage (vacuously)
APPE | append to a file
CDUP | change to parent of current working directory
CWD | change working directory
DELE | delete a file
HELP | give help information
LIST | give list files in a directory (“ls -lgA”)
MKD | make a directory
MDTM | show last modification time of file
MODE | specify data transfer mode
NLST | give name list of files in directory
NOOP | do nothing
PASS | specify password
PASV | prepare for server-to-server transfer
PORT | specify data connection port
PWD | print the current working directory
QUIT | terminate session
REST | restart incomplete transfer
RETR | retrieve a file
RMD | remove a directory
RNFR | specify rename-from file name
RNTO | specify rename-to file name
SITE | non-standard commands (see next section)
SIZE | return size of file
STAT | return status of server
STOR | store a file
STOU | store a file with a unique name
STRU | specify data transfer structure
SYST | show operating system type of server system
TYPE | specify data transfer type
USER | specify user name
XCUP | change to parent of current working directory (deprecated)
XCWD | change working directory (deprecated)
XMKD | make a directory (deprecated)
XPWD | print the current working directory (deprecated)
XRMD | remove a directory (deprecated)
LPSV | prepare for server-to-server transfer, multiprotocol
LPRT | specify data connection port, multiprotocol
EPSV | prepare for server-to-server transfer, multiprotocol
EPRT | specify data connection port, multiprotocol

The following non-standard or UNIX specific commands are supported by the SITE request.

Request | Description
UMASK | change umask, e.g. ``SITE UMASK 002''
IDLE | set idle-timer, e.g. ``SITE IDLE 60''
CHMOD | change mode of a file, e.g. ``SITE CHMOD 755 filename''
HELP | give help information.

The remaining ftp requests specified in Internet RFC 959 are recognized, but not implemented. MDTM and SIZE are not specified in RFC 959, but will appear in the next updated FTP RFC.

The ftp server will abort an active file transfer only when the ABOR command is preceded by a Telnet "Interrupt Process" (IP) signal and a Telnet "Synch" signal in the command Telnet stream, as described in Internet RFC 959. If a STAT command is received during a data transfer, preceded by a Telnet IP and Synch, transfer status will be returned.

Ftpd interprets file names according to the “globbing” conventions used by csh(1). This allows users to utilize the metacharacters “*?[]{}~”.

Ftpd authenticates users according to five rules.

1.  The login name must be in the password data base, /etc/passwd, and not have a null password. In this case a password must be provided by the client before any file operations may be performed. If the user has an S/Key key, the response from a successful USER command will include an S/Key challenge. The client may choose to respond with a PASS command giving either a standard password or an S/Key one-time password. The server will automatically determine which type of password it has been given and attempt to authenticate accordingly. See skey(1) for more information on S/Key authentication. S/Key is a Trademark of Bellcore.

2.  The login name must not appear in the file /etc/ftpusers.

3.  The user must have a standard shell returned by getusershell(3).

4.  If the user name appears in the file /etc/ftpchroot the session's root will be changed to the user's login directory by chroot(2) as for an “anonymous” or “ftp” account (see next item). However, the user must still supply a password. This feature is intended as a compromise between a fully anonymous account and a fully privileged account. The account should also be set up as for an anonymous account.

5.  If the user name is “anonymous” or “ftp”, an anonymous ftp account must be present in the password file (user “ftp”). In this case the user is allowed to log in by specifying any password (by convention an email address for the user should be used as the password).

In the last case, ftpd takes special measures to restrict the client's access privileges. The server performs a chroot(2) to the home directory of the “ftp” user. In order that system security is not breached, it is recommended that the “ftp” subtree be constructed with care, following these rules:

~ftp
    Make the home directory owned by “root” and unwritable by anyone (mode 555).

~ftp/bin
    Make this directory owned by “root” and unwritable by anyone (mode 511). This directory is required, and should contain at least a statically linked copy of ls(1.) Any programs in this directory should be mode 111 (executable only).

~ftp/etc
    Make this directory owned by “root” and unwritable by anyone (mode 511). The files passwd(5) and group(5) must be present for the ls command to be able to produce owner names rather than numbers. The password field in passwd is not used, and should not contain real passwords. The file motd, if present, will be printed after a successful login. These files should be mode 444.

~ftp/pub
    Make this directory mode 555 and owned by “root”. This is traditionally where publically accessible files are stored for download.

FILES
/etc/ftpusers
    List of unwelcome/restricted users.
/etc/ftpchroot
    List of normal users who should be chroot'd.
/etc/ftpwelcome
    Welcome notice.
/etc/motd
    Welcome notice after login.
/etc/nologin
    Displayed and access refused.
/var/run/utmp
    List of users on the system.
/var/log/ftpd
    Log file for anonymous transfers.

SEE ALSO
ftp(1), skey(1), who(1), getusershell(3), ftpusers(5), syslogd(8)

BUGS
The server must run as the super-user to create sockets with privileged port numbers. It maintains an effective user ID of the logged in user, reverting to the super-user only when binding addresses to sockets. The possible security holes have been extensively scrutinized, but are possibly incomplete.

HISTORY
The ftpd command appeared in 4.2BSD.